#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "strlist.h"


void test( int condition, char *string )
{
	if( condition )
	{
		printf( "%s: ok\n", string );
	} else
	{
		printf( "%s: fail\n", string );
	}
}


typedef struct { int n, total; } avg;

void avgcb( char *el, void *avgsofar )
{
	int len = strlen(el);
	avg *data = (avg *)avgsofar;
	data->n++;
	data->total += len;
}


int main( void )
{
	strlist l = strlist_nil();
	test( strlist_kind( l ) == strlist_is_nil,
		"kind(nil) == nil" );

	l = strlist_cons( "duncan", l );

	test( strlist_kind( l ) == strlist_is_cons,
		"kind([duncan]) == cons" );

	strlist tail;
	char *head;
	get_strlist_cons( l, &head, &tail );
	test( strcmp( head, "duncan" ) == 0, "head([duncan]) == duncan" );
	test( strlist_kind( tail ) == strlist_is_nil,
		"kind(tail([duncan])) == nil" );

	l = strlist_cons( "hi", l );
	get_strlist_cons( l, &head, &tail );
	test( strcmp(head, "hi") == 0, "head([hi,duncan]) == hi" );
	get_strlist_cons( tail, &head, &tail );
	test( strcmp(head, "duncan") == 0, "head(tail([hi,duncan])) == duncan" );

	l = strlist_cons( "x", l );
	l = strlist_cons( "y", l );

	char result[1000];
	sprint_strlist( result, l );
	test( strcmp( result, "[ y,x,hi,duncan ]") == 0, "sprint test" );

	avg av;
	av.n     = 0;
	av.total = 0;
	foreach_strlist( avgcb, (void *)&av, l );
	test( av.n == 4, "len list == 4" );
	test( av.total == 10, "total list == 10" );

	free_strlist( l );

	exit(0);
	return(0);
}
