#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "wordlist.h"


void test( int condition, char *string )
{
	if( condition )
	{
		printf( "%s: ok\n", string );
	} else
	{
		printf( "%s: fail\n", string );
	}
}


typedef struct { int n, total; } avg;

void avgcb( char *el, void *avgsofar )
{
	int len = strlen(el);
	avg *data = (avg *)avgsofar;
	data->n++;
	data->total += len;
}


int main( void )
{
	wordlist l = wordlist_nil();
	test( wordlist_kind( l ) == wordlist_is_nil,
		"kind(nil) == nil" );

	l = wordlist_cons( "duncan", l );

	test( wordlist_kind( l ) == wordlist_is_cons,
		"kind([duncan]) == cons" );

	wordlist tail;
	wordlistelement head;
	get_wordlist_cons( l, head, &tail );
	test( strcmp( head, "duncan" ) == 0, "head([duncan]) == duncan" );
	test( wordlist_kind( tail ) == wordlist_is_nil,
		"kind(tail([duncan])) == nil" );

	l = wordlist_cons( "hi", l );
	get_wordlist_cons( l, head, &tail );
	test( strcmp(head, "hi") == 0, "head([hi,duncan]) == hi" );
	get_wordlist_cons( tail, head, &tail );
	test( strcmp(head, "duncan") == 0, "head(tail([hi,duncan])) == duncan" );

	l = wordlist_cons( "x", l );
	l = wordlist_cons( "y", l );

	char result[1000];
	sprint_wordlist( result, l );
	test( strcmp( result, "[ y,x,hi,duncan ]") == 0, "sprint test" );

	avg av;
	av.n     = 0;
	av.total = 0;
	foreach_wordlist( avgcb, (void *)&av, l );
	test( av.n == 4, "len list == 4" );
	test( av.total == 10, "total list == 10" );

	free_wordlist( l );

	return 0;
}
